import scrapy
import time
from douban.items import DoubanItem
from bs4 import BeautifulSoup

class MovieCommentSpider(scrapy.Spider):
    name = 'movie_comment'
    allowed_domains = ['movie.douban.com']
    base_url = 'https://movie.douban.com/subject/35675082/comments'
    count = 0
    start_urls = ['https://movie.douban.com/subject/35675082/comments?limit=20&status=P&sort=new_score']

    def start_requests(self):
        # 该cookie是登陆后获取的cookie字符串。
        # 转换成字典
        cookies = 'll="118281"; bid=3cNGHV-ipe0; __utmz=30149280.1670863196.1.1.utmcsr=baidu|utmccn=(organic)|utmcmd=organic; __utmz=223695111.1670863196.1.1.utmcsr=baidu|utmccn=(organic)|utmcmd=organic; __gads=ID=73ec4789e5484982-22ac33c7d9d80056:T=1670863197:RT=1670863197:S=ALNI_Ma4hO-lg2c4t-zfQ4nDWUwJ79ejSg; Hm_lvt_16a14f3002af32bf3a75dfe352478639=1670863228; __yadk_uid=mddhk2g84vi3aEssPQsyZWapcdPB2Xuq; _vwo_uuid_v2=DC970D3D8EDCA255BED859E8102A610DF|7031e20035df8b3a38ba500d8841e98c; __utmc=30149280; __utmc=223695111; _pk_ref.100001.4cf6=["","",1671034669,"https://www.baidu.com/link?url=QRFtoprJIXlJ-iB3Qs79bQ69hxk5F_fVe9stdJDRWZ0zPDhforMd49Jaayvrh3Vy&wd=&eqid=bd8e2c570012b9990000000663975958"]; _pk_ses.100001.4cf6=*; ap_v=0,6.0; __utma=30149280.1037500366.1670863196.1671023808.1671034669.7; __utma=223695111.2092720778.1670863196.1671023808.1671034669.7; __utmb=223695111.0.10.1671034669; __gpi=UID=00000b8f16973a05:T=1670863197:RT=1671034669:S=ALNI_MbPt-wi2hhCiRytufDALOtPd9cGxA; dbcl2="265452897:8PIZSmUU2qQ"; ck=gvnH; frodotk_db="a5046a9be46ee555ef0d3fd3ad4cafff"; push_noty_num=0; push_doumail_num=0; __utmb=30149280.3.10.1671034669; _pk_id.100001.4cf6=e24e069ac40ca8f0.1670863195.7.1671034830.1671023808.'
        cookies = {i.split("=")[0]: i.split("=")[1] for i in cookies.split("; ")}
        # headers = {"Cookie":cookies}  # cookie放到headers中无效
        yield scrapy.Request(
            self.start_urls[0],
            callback=self.parse,
            cookies=cookies  # 携带cookie进行请求
            # headers = headers  # cookie放到headers中无效
        )


    def parse(self, response):
        self.count += 1
        item = DoubanItem()
        # item = {}
        r = response.text
        soup = BeautifulSoup(r,'lxml')
        comment_set = soup.select('.comment-item')
        for user in comment_set:
            item['comment_date'] = user.select('div.comment > h3 > span.comment-info > span.comment-time')[0].string.strip()
            item['comment_user'] = user.select('div.avatar > a')[0]['title'].strip()
            item['comment_vote'] = user.select('div.comment > h3 > span.comment-vote > span')[0].string.strip()
            item['comment_content'] = user.select('div.comment > p > span.short')[0].string.strip()
            print(item,'\n')
            yield item

        next_page = soup.select('#paginator > a.next')[0]['href'].strip()
        next_url = self.base_url + next_page
        print(next_url)
        time.sleep(1)
        if self.count<29:
            yield scrapy.Request(url=next_url,callback=self.parse)
